#ifndef BASIC_OBJECTS_H
#define BASIC_OBJECTS_H

#include "common.h"
/**
* @class Position
*
* @brief  Controllpoints position
*
*/
// Simple linear volume class which supports loading from DAT files
class Position
{
public:
	Position::Position(float xPosition, float yPosition) : x(xPosition), y(yPosition)
	{}

	Position::Position()
	{}

	float x;
	float y;
};

/**
* 
* @brief  RGB structure
*
*/
struct RGB_Colour
{
public:
	RGB_Colour::RGB_Colour(GLubyte red, GLubyte green, GLubyte blue) : r(red), g(green), b(blue)
	{}

	RGB_Colour::RGB_Colour()
	{}

	GLubyte r;
	GLubyte	g;
	GLubyte	b;
};
/**
* 
* @brief  Lab color class
*
*/
class Lab_Colour
{
public:
	Lab_Colour(GLubyte R, GLubyte G, GLubyte B);
	Lab_Colour(float LValue, float aValue, float bValue) : L(LValue), a(aValue), b(bValue) {}
	Lab_Colour(){}
	float L;
	float a;
	float b;
};
/**
* 
* @brief  RGBA structure
*
*/
struct RGBA_Colour
{
public:
	RGBA_Colour(GLubyte red, GLubyte green, GLubyte blue, GLubyte alpha) : r(red), g(green), b(blue), a(alpha)
	{}
	RGBA_Colour(RGB_Colour colourRGB, GLubyte alpha) : r(colourRGB.r), g(colourRGB.g), b(colourRGB.b), a(alpha)
	{}
	RGBA_Colour(){}
	void setColour(RGB_Colour col, GLubyte alpha);
	void setColour(GLubyte red, GLubyte green, GLubyte blue, GLubyte alpha);
	void setColour(int r, int g, int b, int alpha);
	GLubyte r;
	GLubyte	g;
	GLubyte	b;
	GLubyte	a;
};

enum ColourPickerSliderMode
{
	ColourPickerSliderMode_L,
	ColourPickerSliderMode_A,
	ColourPickerSliderMode_B
};


#endif