#include "ColourPicker.h"

#include "TransferFunctionGUI.h"


GLuint ColourPicker::colourPickerTextureID = -1;
float ColourPicker::colourPickerSliderValue = 0.f;
int ColourPicker::colourPickerOffsetX = 10;

ColourPickerSliderMode ColourPicker::g_iColourPickerLabSwitchMode = ColourPickerSliderMode_L;

int ColourPicker::colourPickerHeight = 180 + TransferFunctionGUI::g_iTransferFunctionTextureDisplayHeight + TransferFunctionGUI::g_iTransferFunctionTextureDisplayYOffset;
int ColourPicker::colourPickerWidth = colourPickerHeight;

RGBA_Colour* ColourPicker::colourPickerTextureData = new RGBA_Colour[colourPickerWidth * colourPickerHeight];



Lab_Colour ColourPicker::getColourPickerPositionColour(float x, float y)
{
	float L = 0.f;
	float a = 0.f;
	float b = 0.f;

	if(g_iColourPickerLabSwitchMode != ColourPickerSliderMode_L)
	{
		L = 100.f * y / (float)colourPickerHeight;
		if(g_iColourPickerLabSwitchMode != ColourPickerSliderMode_A)
		{
			b = colourPickerSliderValue;
			a = 130.f - 260.f * x /(float)colourPickerHeight;
		}
		else
		{
			a = colourPickerSliderValue;
			b = 130.f - 260.f * x /(float)colourPickerHeight;
		}
	}
	else
	{
		L = colourPickerSliderValue;
		a = 130.f - 260.f * x /(float) colourPickerWidth;
		b = 130.f - 260.f * y /(float)colourPickerHeight;
	}

	return Lab_Colour(L, a, b);
}

void ColourPicker::initColourPickerTexture()
{
	glGenTextures(1, &colourPickerTextureID);

	get_errors();

	if(colourPickerTextureID != GLuint(-1))
	{
		get_errors();
		glBindTexture(GL_TEXTURE_2D, colourPickerTextureID);

		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S, GL_CLAMP);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T, GL_CLAMP);

		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);

		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, colourPickerWidth, colourPickerHeight, 0, GL_RGBA, GL_UNSIGNED_BYTE, NULL);

		get_errors();
	}

	refreshColourPickerTexture(glutGetWindow());
}



void ColourPicker::refreshColourPickerTexture(int windowID)
{
	glutSetWindow(windowID);

	for(int y = 0; y < colourPickerHeight; ++y)
	{
		for(int x = 0; x < colourPickerWidth; ++x)
		{
			int i = colourPickerWidth * y + x;

			Lab_Colour colour = getColourPickerPositionColour((float)x, (float)y);

			colourPickerTextureData[i] = RGBA_Colour(toRGB(colour), GLubyte(255));
		}
	}
	if(colourPickerTextureID != GLuint(-1))
	{
		glBindTexture(GL_TEXTURE_2D, colourPickerTextureID);
		glTexSubImage2D(GL_TEXTURE_2D, 0, 0, 0, colourPickerWidth, colourPickerHeight, GL_RGBA, GL_UNSIGNED_BYTE, colourPickerTextureData);
		get_errors();
	}

}