#ifndef COLOUR_PICKER_H
#define COLOUR_PICKER_H

#include "utility.h"

#include "BasicObjects.h"
#include "Colours.h"

using namespace Colours;
/**
* @class ColourPicker
*
* @brief  RGB and Lab color picker
*
*/ 

class ColourPicker
{
public:
	static void initColourPickerTexture();
	static void refreshColourPickerTexture(int windowID);
	static Lab_Colour getColourPickerPositionColour(float x, float y);

	static GLuint colourPickerTextureID;

	static int colourPickerHeight;
	static int colourPickerWidth;


	static RGBA_Colour* colourPickerTextureData;

	static int colourPickerOffsetX;

	static float colourPickerSliderValue;

	static ColourPickerSliderMode g_iColourPickerLabSwitchMode;
};

#endif