#ifndef COLOURS_H
#define COLOURS_H

#include "BasicObjects.h"

namespace Colours
{
	//Umrechnung von RGB auf XYZ
	float toX(GLubyte R, GLubyte G, GLubyte B);
	float toY(GLubyte R, GLubyte G, GLubyte B);
	float toZ(GLubyte R, GLubyte G, GLubyte B);
	float toX(float R, float G, float B);
	float toY(float R, float G, float B);
	float toZ(float R, float G, float B);
	//Berechnung der L a und b Komponenten aus dem Lab-Farbraum
	float toL(float Y);
	float toA(float X, float Y);
	float toB(float Y, float Z);

	//Rckrechnung von Lab in RGB
	RGB_Colour toRGB(Lab_Colour colour);
	RGB_Colour toRGB(float L, float a, float b);


	//Lineare interpolation von Farben
	RGB_Colour		linearInterpolationRGB(float interPolBalance, RGB_Colour &start, RGB_Colour &end);
	RGBA_Colour		linearInterpolationRGBA(float interPolBalance, RGBA_Colour &start, RGBA_Colour &end);
	GLubyte			linearInterpolationAlpha(float interPolBalance, GLubyte startAlpha, GLubyte endAlpha);
	Lab_Colour		linearInterpolationLab(float interPolBalance, Lab_Colour &start, Lab_Colour &end);

	void clampInterpolationValue(float& interPolBalance);

	//Normierten Bezugsgren fr Lab Berechnung
	//Fr CIELab (D65)
	const float Xn = 0.95047f;
	const float Yn = 1.00000f;
	const float Zn = 1.08883f;
	
	//Vergleichswert fr die Kalkulation von Lab bei geringen P/Pn Werten (P/Pn < LAB_COMPARE_VALUE_CONST)
	const float LAB_COMPARE_VALUE_CONST = 0.00885645167903563081717167575546f;

	//Helferfunktionen fr Lab Einzelkomponentenberechnung
	 float normCalc( float div );
	 float XNormCalc(float X);
	 float YNormCalc(float Y);
	 float ZNormCalc(float Z);
}


#endif