#ifndef GLEW_CONTENT_MANAGEMENT_H
#define GLEW_CONTENT_MANAGEMENT_H

#include "common.h"

/**
* @class GlewContentManagement
*
* @brief  Manages multiple render contexts of subwindows
*
*/

class GlewContentManagement
{
public:
	static GlewContentManagement* getInstance();

	GLEWContext* getCurrentGlewContent();

	void initRenderWindowContext();
	void initBottomWindowContext();
	void initRightWindowContext();
	void initMainWindowContext();

	void initGlew();
private:
	GlewContentManagement();
	~GlewContentManagement();
	GlewContentManagement(const GlewContentManagement &);
	GlewContentManagement & operator=(const GlewContentManagement &);

	static GlewContentManagement*	instance;
	static bool						initialized;

	GLEWContext* m_GlewRenderWindowContext;
	GLEWContext* m_GlewBottomWindowContext;
	GLEWContext* m_GlewRightWindowContext;
	GLEWContext* m_GlewMainWindowContext;

	int m_RenderWindowID;
	int m_BottomWindowID;
	int m_RightWindowID;
	int m_MainWindowID;
};


GLEWContext* glewGetContext();


#endif