#ifndef HISTOGRAM_DRAW_H
#define HISTOGRAM_DRAW_H

#include <vector>

class Volume;

enum HistogramDrawType
{
	HISTOGRAM_DRAW_NONE,
	HISTOGRAM_DRAW_LINEAR,
	HISTOGRAM_DRAW_LOG
};
/**
* @class HistogramDraw
*
* @brief  Draw linear or logarithmic histogram
*
*/

class HistogramDraw
{
public:
	static HistogramDraw* getInstance();

	void refreshHistogramDrawData(Volume& volume);

	void calculateLogarithmicHistogramData();
	void rescaleHistogramDataToHighestValue( std::vector<double> &normalizedHistogramData );
	void draw();
	void setDrawType(HistogramDrawType drawType);


private: 
	HistogramDraw();
	~HistogramDraw();
	HistogramDraw(const HistogramDraw &);
	HistogramDraw & operator=(const HistogramDraw &);



	static HistogramDraw*	_instance;
	static bool				initialized;
	
	
	HistogramDrawType		m_HistogramDrawType;
	float*					m_HistogramData;
	float*					m_HistogramDataLogarithmic;
	int						m_HistogramDataSize;
};



#endif