#ifndef SHADERMANAGER_HPP
#define SHADERMANAGER_HPP

#include "Shader.hpp"

#include <map>
#include <string>

/**
* @class ShaderManager
*
* @brief  Manages shader files
*
*/

class ShaderManager {
public:
	virtual ~ShaderManager(void);
	
	static ShaderManager *getInstance(void);
	
	Shader *getShader(unsigned int id);
	void loadShader(unsigned int id, std::string path);
private:
	static ShaderManager *m_instance;

	std::map<unsigned int, Shader *> m_shaders;

	ShaderManager(void);
};

#endif