#ifndef TRANSFER_FUNCTION_TEXTURE_H
#define TRANSFER_FUNCTION_TEXTURE_H

#include "BasicObjects.h"
#include "common.h"
#include "TFControlPoint.h"

#include "TransferFunctionGUI.h"

#include <vector>


class TFControlPoint;


enum Window
{
	WINDOW_BOTTOM,
	WINDOW_RENDERING
};

/**
* @class TransferFunctionTexture
*
* @brief Handles transferfunction texture
*
*/


class TransferFunctionTexture
{

public:
	static void initTransferFunctionTexture(int windowID, Window window);

	static void refreshTransferFunctionTextureData();
	static void refreshTransferTextureDataWithControlPoints();

	static void copyDataToTransferFunctionTexture(int windowID, Window window);	

	//1D TransferTexture
	static const int transferFunctionTextureWidth = 4096;
	static GLuint bottomWindowTransferFunctionTextureID;
	static GLuint renderWindowTransferFunctionTextureID;

	static RGBA_Colour transferFunctionTexture[transferFunctionTextureWidth];
};

#endif